
pro mplan_getid, filename=filename, target_name, target_id, path=path, gid=gid

   if n_elements(path) eq 0 then path = ''
                                restore, path+'pros/read_src_temp1.idl'
                             data = read_ascii(filename, template=temp1)
                             target_name = data.name

   if file_search(path+'pros/target_id.idl') eq '' then begin
        widget_control, gid, /append,set_value=['Creating target ID list...','']
        target_id = get_src_name(target_name)
       
        src_list = target_name
        src_id   = target_id
   endif else begin
        restore, path+'pros/target_id.idl'
        
        n_src = n_elements(target_name)
        target_id = target_name   ; creat a target_id array
        target_exist = intarr(n_src)
        verbose =1
       
        For n=0, n_src-1 do begin
             idx = where(src_list eq target_name[n], cnt)
             if cnt eq 0 then begin
                target_exist[n] = 0
                target_id[n] = get_src_name(target_name[n])
             
                if verbose eq 1 then widget_control, gid, /append,set_value=['Querying SIMBAD to update target ID list...','']
                verbose =0 
             endif else begin
    
                target_exist[n] =1 
                target_id[n] = src_id[idx[0]]
             endelse
        Endfor

        ind = where(target_exist eq 0, cnt)
        if cnt ne 0 then begin
           src_list = [src_list, target_name[ind]]
           src_id   = [src_id, target_id[ind]]
        endif
    Endelse 

    save, src_list, src_id, filename=path+'pros/target_id.idl'
          
END

 
