
; Pro to make a GUI for MIRC observation planning.
;
;

PRO mplan_cleanup, id

widget_control, id, get_uvalue=Pinfo

if ptr_valid((*Pinfo).values.tabinfo) then ptr_free,  (*Pinfo).values.tabinfo
ptr_free, Pinfo
print, 'widget closed ...'

end


PRO wglayout_mplan

; Creat top level base

top = widget_base(tit='MIRC Observation Planning Tool', TLB_FRAME_ATTR=1)


tab_top = widget_tab(top, uvalue='Tab')


tab1 =  widget_base(tab_top, tit=' Plan for Observation ', row=3, /base_align_center, uvalue='Tab1')
base2 = widget_base(tab1, row=2, frame=0)
base3 = widget_base(tab1, row=2, frame=1)
base4 = widget_base(tab1, row=2, frame=1)

tab2 =  widget_base(tab_top, tit=' UV & Vis2 ', row=2, uvalue='Tab2')
base1 = widget_base(tab2, row=6, frame=1)


 ; Tab2 components
      ; Tab 2 title
   base1_tit = widget_base(base1)
   base1_tit_text = widget_label(base1_tit, value=' Check UV coverage and Vis2 for individual target ', frame=3)
   base1_help = widget_button(base1_tit, value='     Help    ', xoffset= 590, uvalue='Help1' )

   line1 = widget_base(base1, row=1, /base_align_center, tit='Tool 2')
   l1_label0 = widget_label(line1, value='Target:')
;   l1_text0  = widget_text(line1, /editable, xsize=14, uvalue='Target',/all_events)
;   l1_button1= widget_button(line1, value='Select')
   l1_text0 = widget_combobox(line1, /editable, xsize=120, SCR_YSIZE=30, uvalue='Target')

   l1_label1 = widget_label(line1, value='  R.A:')
   l1_text1   = widget_text(line1, /editable, xsize=14,  uvalue='RA',/all_events)
;   l1_button1= widget_button(line1, value='Browse...')

   l1_label2 = widget_label(line1, value='  Dec:')
   l1_text2   = widget_text(line1, /editable, xsize=13, uvalue='Dec',/all_events)

   l1_label6a = widget_label(line1, value='  Diam')
   l1_text5   = widget_text(line1, /editable, xsize=7, uvalue='Diam',/all_events)
   l1_label6 = widget_label(line1, value='mas')
  
   l1_drop1 = widget_droplist(line1, value=['H Band', 'K Band'], uvalue='tab2_band')

;   l1_button2= widget_button(line1, value='Browse...')

   line2 = widget_base(base1, row=1, /base_align_center)
   l1_label3 = widget_label(line2, value='HA:')
   l1_text3   = widget_text(line2, /editable, xsize=6, uvalue='HA_from',/all_events)
   
   l1_label4 = widget_label(line2, value=' to')
   l1_text4   = widget_text(line2, /editable, xsize=6, uvalue='HA_to',/all_events)

   l1_label5 = widget_label(line2, value='Hrs   ')


   line4 = widget_base(line2,row=1)
     line4_a =widget_label(line4, value='Tele :', yoff=5)
     line4_b = widget_base(line4, /nonexclusive, /grid_layout, row=1)
       line4_s1 = widget_button(line4_b, value='S1', uvalue='Tab2_S1')
       line4_s2 = widget_button(line4_b, value='S2', uvalue='Tab2_S2')
       line4_e1 = widget_button(line4_b, value='E1', uvalue='Tab2_E1')
       line4_e2 = widget_button(line4_b, value='E2', uvalue='Tab2_E2')
       line4_w1 = widget_button(line4_b, value='W1', uvalue='Tab2_W1')
       line4_w2 = widget_button(line4_b, value='W2', uvalue='Tab2_W2')

     l1_button1= widget_button(line4, value='  Plot Vis2  ', uvalue='calV2', xoff=390)
     line6_c = widget_button(line4, value='    Save    ', uvalue='save_vis2', xoff=590)
    

   line3 = widget_text(base1, ysize=11, xsize=108, value=b1_text,/scroll, uvalue='b1_text', frame=1)

   line5 = widget_draw(base1, xsize=700, ysize=330, retain=2, uvalue='b1_draw')

;   line2 = widget_base(base1, row=1, /base_align_center)
 

  ; base2 components

    b2_col = widget_base(base2, column=2, /base_align_center, tit='Step 1') 
    b2_c1  = widget_base(b2_col, row=3,frame=1)
      ; base2 title
    b2_tit = widget_base(b2_c1)
    b2_tit_text = widget_label(b2_tit, value=' Input target list & Plot sky map ', frame=3)
    b2_help = widget_button(b2_tit, value=' Help ', xoff=312, uvalue='Help2')
      ; base2 column row1
    b2_c1_r1 = widget_base(b2_c1, row=2)    
    b2_c1_label1 = widget_label(b2_c1_r1, value='Target List:')
    b2_c1_text1  = widget_text(b2_c1_r1, /editable, xsize=35, uvalue='Input1', /all_events) 
    b2_c1_button1= widget_button(b2_c1_r1, value='Browse', uvalue='Browse1a')

    b2_c1_label2 = widget_label(b2_c1_r1, value='Output PLot:')
    b2_c1_text2  = widget_text(b2_c1_r1, /editable, xsize=35, uvalue='Output1', /all_events) 
    b2_c1_button2= widget_button(b2_c1_r1, value='Browse', uvalue='Browse1b')
     ; base2 row2
    b2_c1_r2 = widget_base(b2_c1, /base_align_center)
    b2_c1_r2_label0 = widget_label(b2_c1_r2, value='Observing Date:', yoff=5)

    time=systime()
    mon_str=['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec']
    mon=strmid(time, 4,3)
    mon_ind=where(mon_str eq mon)+1
    mon = reform(strtrim(string(mon_ind),2))
    year= strmid(time, 20,4)
    day = strtrim(strmid(time, 8,2),2)
    b2_c1_r2_text1  = widget_text(b2_c1_r2,  value=mon, xoff=100, xsize=2,/editable, uvalue='obsmon',/all_events)
    b2_c1_r2_text2  = widget_text(b2_c1_r2, value=day, xoff=140, xsize=2, /editable, uvalue='obsday',/all_events)
    b2_c1_r2_text3  = widget_text(b2_c1_r2, value=year, xoff=180, xsize=4, /editable, uvalue='obsyear', /all_events)
    b2_c1_r2_label2 = widget_label(b2_c1_r2, value='mon', xoff=100, yoff=30)
    b2_c1_r2_label3 = widget_label(b2_c1_r2, value='day', xoff=140, yoff=30)
    b2_c1_r2_label4 = widget_label(b2_c1_r2, value='year', xoff=180, yoff=30)
      ; base2 row3
    b2_c1_button3= widget_button(b2_c1_r2, value='Check plot',xoff=228, yoff=6, uvalue='checkplot1')
    b2_c1_button4= widget_button(b2_c1_r2, value='  Save  ', xoff=302, yoff=6, uvalue='Save1') 


  ; base3 components

    b3_c1 = widget_base(b2_col, row=6, frame=1, tit='Step 2')
       ; base3 title
    b3_tit = widget_base(b3_c1)
    b3_tit_text = widget_label(b3_tit,value=' Choose Teles & Plot given POP coverage ',frame=3)
    b3_help = widget_button(b3_tit, value=' Help ', xoffset=260, uvalue='Help3')
       ; base3 row1
    b3_row1 = widget_base(b3_c1, /BASE_ALIGN_top )
    b3_row1_label = widget_label(b3_row1, value='  Tele: ', yoff=8)
    b3_row1_b = widget_base(b3_row1, column=7, /nonexclusive, /grid_layout, xoff=50)
       b3_row1_button1 = widget_button(b3_row1_b, value='S1', uvalue='S1')
       b3_row1_button2 = widget_button(b3_row1_b, value='S2', uvalue='S2')      
       b3_row1_button3 = widget_button(b3_row1_b, value='E1', uvalue='E1')
       b3_row1_button4 = widget_button(b3_row1_b, value='E2', uvalue='E2')
       b3_row1_button5 = widget_button(b3_row1_b, value='W1', uvalue='W1')
       b3_row1_button6 = widget_button(b3_row1_b, value='W2', uvalue='W2')
         ; base3 row2
    b3_row2 = widget_base(b3_c1);, column=7)
       b3_row2_label = widget_label(b3_row2, value='POP:', xoff= 16)
       b3_row2_label2= widget_label(b3_row2, value='(1-5)', xoff= 14, yoff=15)
       b3_row2_text1 = widget_text(b3_row2, xsize=1, xoffset=63 -9, /editable, /all_events, uvalue='POP_S1', sensitive=0)
       b3_row2_text2 = widget_text(b3_row2, xsize=1, xoffset=103-9, /editable, /all_events, uvalue='POP_S2', sensitive=0)
       b3_row2_text3 = widget_text(b3_row2, xsize=1, xoffset=143-9, /editable,/all_events, uvalue='POP_E1', sensitive=0)
       b3_row2_text4 = widget_text(b3_row2, xsize=1, xoffset=183-9, /editable,/all_events, uvalue='POP_E2', sensitive=0)
       b3_row2_text5 = widget_text(b3_row2, xsize=1, xoffset=223-9, /editable,/all_events, uvalue='POP_W1', sensitive=0)
       b3_row2_text6 = widget_text(b3_row2, xsize=1, xoffset=263-9, /editable,/all_events, uvalue='POP_W2', sensitive=0)
         ; base3 row3
    b3_row3 = widget_base(b3_c1, /BASE_ALIGN_top)
    b3_row3_label = widget_label(b3_row3, value='Fix POP:', yoff=6)
    b3_row3_b = widget_base(b3_row3, column=7, /nonexclusive, /grid_layout, yoff=0, xoff=50)
       b3_row3_button1 = widget_button(b3_row3_b, value='  ', uvalue='FixS1')
       b3_row3_button2 = widget_button(b3_row3_b, value='  ', uvalue='FixS2')
       b3_row3_button3 = widget_button(b3_row3_b, value='  ', uvalue='FixE1')
       b3_row3_button4 = widget_button(b3_row3_b, value='  ', uvalue='FixE2')
       b3_row3_button5 = widget_button(b3_row3_b, value='  ', uvalue='FixW1')
       b3_row3_button6 = widget_button(b3_row3_b, value='  ', uvalue='FixW2')


       ; base3 row 4
;    b3_row4 = widget_base(b3_c1)
;       b3_row4_label = widget_label(b3_row4, value='OutFile:')
;       b3_row4_text  = widget_text(b3_row4, /editable,  xsize=30, uvalue='Outfile2',/all_events)
;       b3_row4_button1 = widget_button(b3_row4, value='Browse', uvalue='Browse2')
       b3_row2_button= widget_button(b3_row3, value=' Check POP Plot  ', uvalue='Plot2', xoff=70, yoff=28)
       b3_row4_button2  = widget_button(b3_row3, value='  Save plot  ', uvalue='Save2', xoff=195, yoff=28)
    b3_row5 = widget_base(b3_c1)

       ; base 4 (although labeled as b3)
    b3b = widget_base(base3, row=6, tit='Step 3')
       ; base4 title
     b3b_tit = widget_base(b3b)
     b3b_tit_text = widget_label(b3b_tit, frame=3, value='Optimize observation schedule for the target list' )
     b3b_help2 = widget_button(b3b_tit, value='    Help    ', xoffset=602, uvalue='Help4')

       ; base4 row 1
     b3b_row1 = widget_base(b3b)
         b3b_row1_drop = widget_droplist(b3b_row1, value=[' 1 ',' 2 '], tit='Optimization:', uvalue='optmethod')
     b3b_row2 = widget_text(b3b_row1, uvalue='b3_text', frame=0, xsize=50, xoff=145)
        b3_row2_text_value = ['Optimize total observable time', 'Optimize observable time for high priority targets']
        b3b_row2_button1 = widget_button(b3b_row1, value=' Set target priority', uvalue='priority', xoff=550, ysize=30)


       ;base4 row 2. The names are a bit of mess
     b3b_new1 = widget_base(b3b)
        b3b_new1_drop = widget_droplist(b3b_new1, value=[' 1 ',' 2 '], tit=' Sort method:', uvalue='sortmethod')
        b3b_new1_text_value = ['Sort targets by their observable duration', 'Sort targets by their observation start & end time']
        b3b_new1_text = widget_text(b3b_new1, uvalue='b3_text2', frame=0, xsize=50, xoff=145)
        b3b_new1_label = widget_label(b3b_new1, yoff=8, value='# of output blocks:', xoff=530)
        b3b_text6 = widget_text(b3b_new1, uvalue='n_output',value='3', xoff=650, xsize=2, frame=0,/editable,/all_events)
;        b3b_new1_

      b3b_new2 = widget_base(b3b)
        b3b_new2_label = widget_label(b3b_new2, yoff=8,value='Start at')
        b3b_new2_label2= widget_label(b3b_new2, yoff=8,value='hrs after sunset', xoff=90)
        b3b_new2_label3= widget_label(b3b_new2, yoff=8,value='End at', xoff=220)        
        b3b_new2_label4= widget_label(b3b_new2, yoff=8,value='hrs before sunrise', xoff = 295)
        b3b_text3 = widget_text(b3b_new2, uvalue='starttime', value='1.0', frame=0, xsize=3, xoff=55,/editable, /all_events)
        b3b_text4 = widget_text(b3b_new2, uvalue='endtime', value='0.5', frame=0, xsize=3, xoff=260,/editable, /all_events)

        b3b_new2_label5 = widget_label(b3b_new2, yoff=8, xoff = 442, value='Obs Time threshold:')
        b3b_text5 = widget_text(b3b_new2, uvalue='timeshreshold', value='0.5', frame=0, xsize=3, xoff=559,/editable, /all_events)
        b3b_new2_label6 = widget_label(b3b_new2, yoff=8, xoff = 595, value='hrs')


     b3b_row3 = widget_base(b3b)
     b3b_row3_lab = widget_label(b3b_row3, value='Outfile: ', yoff=8)
     b3b_row3_text = widget_text(b3b_row3, uvalue='Output3',value='(Use default)', frame=0, xsize=45, xoff=58,/editable,/all_events)
     b3b_row3_button = widget_button(b3b_row3, uvalue='Browse3', xoff = 345, value='Browse', yoff=3)
     b3b_row2_button2 = widget_button(b3b_row3, value='    Optimize    ', uvalue='Optimize', xoff=575,  ysize=30)

     b3b_row3_base2 = widget_base(b3b_row3, xoff=435, /NONEXCLUSIVE)   
     b3b_row3_button3 = widget_button(b3b_row3_base2, value='Query target ID', uvalue='ID')

; base4 components

  b4 = widget_text(base4, ysize=18, xsize=109, value=b4_text,/scroll, uvalue='b4_text')


; ------ pack the info into a structure ---------------------

    ; values from widgets
 values = {tabinfo:ptr_new(), $
 target: '',  $
 target_ind: 0, $
 ra_str: '' ,       $
 dec_str:'',      $
 ha_from:'',  $
 ha_to:'',    $
 diam:'',     $
 Tab2_s1:0,  $
 Tab2_s2:0,  $
 Tab2_e1:0,  $
 Tab2_e2:0,  $
 Tab2_w1:0,  $
 Tab2_w2:0,  $
 tab2_nops:1 , $
 output_tab2:'', $
 tab2_band:0 ,  $
 input1:'',      $
 output1:'',     $
 obsmon:mon,   $
 obsday:day,   $
 obsyr:year,    $
 s1:0,         $
 s2:0,         $
 e1:0,         $
 e2:0,         $
 w1:0,         $
 w2:0,         $
 pop_s1:0 ,      $
 pop_s2:0 ,      $
 pop_e1:0 ,      $
 pop_e2:0 ,      $
 pop_w1:0 ,      $
 pop_w2:0 ,      $
 fixpop_s1:0,    $ 
 fixpop_s2:0,    $
 fixpop_e1:0,    $
 fixpop_e2:0,    $
 fixpop_w1:0,    $
 fixpop_w2:0,    $
 Tname:'',       $
 popname:'',     $
 outfile2:'',      $
 b3_text:'',       $
 optmethod:1,      $
 starttime:1.0,    $
 endtime:0.5,      $
 timeshreshold:0.5, $
 n_output:3,        $
 sort: 1,        $
 outfile3:'',    $
 getid: 1    }


 info = {values:values, $  
         tab:tab_top,       $
 help1: base1_help, $   ; widget_ids
 target: l1_text0,  $
 ra:l1_text1,       $
 dec:l1_text2,      $
 ha_from:l1_text3,  $
 ha_to:l1_text4,    $
 diam:l1_text5,     $
 b1_text:line3,     $
 Tab2_s1:line4_s1,  $
 Tab2_s2:line4_s2,  $
 Tab2_e1:line4_e1,  $
 Tab2_e2:line4_e2,  $
 Tab2_w1:line4_w1,  $
 Tab2_w2:line4_w2,  $ 
 save_vis2:line6_c, $
 calV2:l1_button1,$
 b1_draw: line5,    $
 tab2_band:l1_drop1, $
 help2: b2_help,          $
 input1:b2_c1_text1,      $
 browse1a:b2_c1_button1,  $
 output1:b2_c1_text2,     $
 browse1b:b2_c1_button2,  $
 obsmon:b2_c1_r2_text1,   $
 obsday:b2_c1_r2_text2,   $
 obsyr:b2_c1_r2_text3,    $
 checkplot1:b2_c1_button3,$
 save1:b2_c1_button4,     $
 help3:b3_help,              $
 s1:b3_row1_button1,         $
 s2:b3_row1_button2,         $
 e1:b3_row1_button3,         $
 e2:b3_row1_button4,         $
 w1:b3_row1_button5,         $
 w2:b3_row1_button6,         $
 pop_s1:b3_row2_text1 ,      $
 pop_s2:b3_row2_text2 ,      $
 pop_e1:b3_row2_text3 ,      $
 pop_e2:b3_row2_text4 ,      $
 pop_w1:b3_row2_text5 ,      $
 pop_w2:b3_row2_text6 ,      $
 plot2: b3_row2_button,      $
 b3_text:b3b_row2,       $
 save2:b3_row4_button2,      $
 help4:b3b_help2,           $
 optmethod:b3b_row1_drop,   $
 priority:b3b_row2_button1, $ 
 optimize:b3b_row2_button2, $ 
 output3:b3b_row3_text, $
 browse3:b3b_row3_button, $
 b4_text:b4,              $
 fixS1: b3_row3_button1,  $
 fixS2: b3_row3_button2,  $ 
 fixE1: b3_row3_button3,  $ 
 fixE2: b3_row3_button4,  $ 
 fixW1: b3_row3_button5,  $ 
 fixW2: b3_row3_button6,  $  
 n_output: b3b_text6,     $
 starttime: b3b_text3,    $
 endtime:   b3b_text4,    $
 sort: b3b_new1_drop,     $ 
 sort_text: b3b_new1_text, $
 timeshreshold: b3b_text5, $
 ID: b3b_row3_button3  }

 Pinfo = ptr_new(info, /no_copy)


; set up some initial values
widget_control, (*Pinfo).b3_text, set_value=b3_row2_text_value[(*Pinfo).values.optmethod]
widget_control, (*Pinfo).optmethod, SET_DROPLIST_SELECT=(*Pinfo).values.optmethod

widget_control, (*Pinfo).sort_text, set_value=b3b_new1_text_value[(*Pinfo).values.sort]
widget_control, (*Pinfo).sort, SET_DROPLIST_SELECT=(*Pinfo).values.sort
widget_control, (*Pinfo).tab2_band, SET_DROPLIST_SELECT=(*Pinfo).values.tab2_band
widget_control, (*Pinfo).id, set_button=(*Pinfo).values.getid
;
; Realize widgets 

widget_control, top, /realize
widget_control, top, set_uvalue=Pinfo, /no_copy
wset

xmanager, 'mplan', top,/no_block, cleanup='mplan_cleanup'

print, '-->Done!'

END






