; input data,nreads
; will do coadds, ignoring first read.

function mirc_coadd,data,nreads
if keyword_set(nreads) eq 0 then nreads=8 ; default
dims=size(data,/dim)
dimx=dims(0)/nreads
dimy=dims(1)
dimz=dims(2)

out=fltarr(dimx,dimy,dimz)

xv=findgen(dimx)*nreads
for i=1,nreads-1 do begin
  out=out+data(xv+i,*,*)
endfor
out=out/(nreads-1.)
return,out
end
 

