function mircsigma,data

; don't take difference. just do a sigma filter for each pixel vs time.


info=size(data,/dim)
; Assmume data is 3-d. (x,y,frames)
xdim=info(0)
ydim=info(1)
zdim=info(2)

ndim=3
data0=data

nch=0
nsig=10.
nmed=5
for i=0,xdim-1 do begin
 for j=0,ydim-1 do begin
  y=reform(data0(i,j,*))
  medy=medsmooth(y,nmed)
  diff=y-medy
 ;FAST ROBUST RMS
  diffo=diff(sort(diff))
  rms=stdev(diffo( (.1*zdim):(.9*zdim))) > (2.) ; set min rms to 
						; guard against some funny
						; integer business
  in=where( (abs(diff) gt (nsig*rms)),ct)
  nch=nch+ct
  ;if (i eq 40 and j eq 4) then stop
  if ct gt 100  then stop
  if ct gt 0 then y(in)=medy(in)
  

  data0(i,j,*)=y
endfor
endfor
print,'Number of Pixels Changed: ',nch,' out of ',n_elements(data0)

return,data0
end


