; JDM 2001Sep15

function boot_angles, angles, weights = weights, angs=angs
;JDM 2004Jun05 FIXED MAJOR BUG would under(over)estimate error if
; number of element in angles array is less(over) num_boots
;ASSUME ANGLES IN DEGREES!
num=n_elements(angles)
if (keyword_set(weights) eq 0) then weights = replicate(1.0,num)



num_boots = 200

rps = fltarr(num_boots)
ips = fltarr(num_boots)
angs = fltarr(num_boots)

for i=0,num_boots-1 do begin
 boot_in = fix(num*randomu(seed,num))

 rp0=total(  weights(boot_in)*cos(!pi*angles(boot_in)/180.) )
 ip0=total(  weights(boot_in)*sin(!pi*angles(boot_in)/180.) )
 
 rps(i)=rp0
 ips(i)=ip0

 angs(i) = mod360(180.*atan( ip0,rp0)/!pi)
endfor

mn = (angle_stats(angs))(0)
sd = robust_sigma( angle_diff(angs,mn) )
;sd = robust_sigma( angle_diff(angs,mn) )
;stop
return,[mod360(mn),sd]
end
 
