function boot_ratio,x,y,num_samples=num_samples,result=result


;  This will pass Bootstrapped samples of x,y to
; mean_ratio and return the result.

; The function will return a vector of NUM_SAMPLES 
; with each realization of the bootstrap.


if (keyword_set(num_samples) eq 0) then num_samples=100
x=reform(x)
y=reform(y)
x_num=(size(x))(1)

answer=fltarr(num_samples)
for i=0,num_samples-1 do begin
  index=x_num*randomu(seed,x_num)
;  print,i,',',index
;  answer(i)=mean_ratio(x(index),y(index))
  answer(i)=total(x(index))/total(y(index))
endfor
result=[robust_mean(answer,sig=sig),sig]

return,answer
end

