; JDM
; 09Aug2000
;
; used to get data in format  2000Jan05
;
; if nothing passed, then do so for current date.
;
;  example:
;   print,get_fluordate(month=1,day=11,year=1972)
;  IDL> 1972Jan11
function get_fluordate,month=month1,day=day1,year=year1

if (keyword_set(month1) eq 0) then begin
  date=systime()
  day=strcompress(strmid(date,8,2),/rem)
  if (strlen(day) eq 1) then day='0'+day
  result=strcompress(strmid(date,20,4)+strmid(date,4,3)+day,/rem)
endif else begin
  day=strcompress(string(fix(day1)),/rem)
  if (strlen(day) eq 1) then day='0'+day
  year=strcompress(string(fix(year1)),/rem)
 case (fix(month1)) OF
     1: month="Jan"
     2: month="Feb"
     3: month="Mar"
     4: Month="Apr"
     5: Month="May"
     6: Month="Jun"
     7: Month="Jul"  
     8: Month="Aug"
     9: Month="Sep
    10: Month="Oct"
    11: Month="Nov"
    12: Month="Dec"
  else: month="duh"
 endcase
 
 result=year+month+day 
endelse 

return,result
end

