; 2006Dec21 JDM
; Calculates the mean photometric signal from
;    shutter data.
; 2007Jun22 JDM  does optimal job with fft.
;    ** obsolete **

pro mirc_photohelper1,  file0,ave_bg,z0,$   ;INPUT
 profiles,  phot, ps, 	$		    ;OUTPUTS
 hanwindow=hanwindow, $			    ;OPTIONS
 smoothl = smoothl

; smoothl is the width to smooth background in calculating the 
; power specturm -- allows the zero padding to be smooth and
; should not erase the modulcatin hopefully.

dims=size(ave_bg,/dim)
dimx=dims(0)
dimy=dims(1)
dimz=dims(2)
if keyword_set(smoothl) eq 0 then smoothl=dimz/20.

if (keyword_set(hanwindow) eq 1) then begin
han=hanning(dimx)#replicate(1.d0,dimy)
han3d=rebin(han,dimx,dimy,dimz)
endif else han3d=replicate(1.0,dimx,dimy,dimz)


 td0=float(readfits(file0,head,/silent))-ave_bg
 satframe=sxpar(head,'SATFRAME')
 if satframe le (z0+3) then satframe = dimz-1
 z1 = satframe < (dimz-3) ; ignore last 3 frames.

 profiles=reform((td0(*,*,z1)-td0(*,*,z0))/ $
       (z1-z0)) ; result is the Slope counts/frame.


 dd=diffdata(td0,sigma=sigmaon,/nodiff ) * han3d
 dd=total( total(dd,1),1)
 phot=dd ; not zero padded..


; new version
dd=dd-mean(dd)
dd=dd-mirc_linfit(dd)*findgen(n_elements(dd))
dd=dd-mean(dd)

x=shift(findgen(dimz),-dimz/2)
x=x-x(0)
wf=exp(-alog(2)*(x*smoothl*2/dimz)^2)
ddsmooth = fft_filter(dd,wf)

 dd=dd-ddsmooth

 dd(0:(z0-1))=0.         ; zero padding
 dd((z1+1):(dimz-1))=0. ; zero padding
 f=1.-((z0+dimz-z1-1)*1.0/dimz) ; fraction ok
 ps=(abs( fft(dd) ))^2 / (f*f) ; corrects for
; f-factor: corrects for the fraction of data that are zero-padded.

;print,z0,z1,file0
;if satframe lt (dimz-1) then stop


end
