; 2006Dec21 JDM  Helper for mirc_process3a.
; requires 3-dimensional arrays.... (x,y,z) where loop for values i over z.

pro mirc_photohelper2, profiles, $   dimx,dimy,dimz
  profile_b1,profile_b2,profile_b3,profile_b4, $
  weights = wt_function,$ 	;INPUTS
  flux_all,chi2_all,$  		 	;OUTPUT
  spec=spec, flux_sigma=flux_sigma,flux_incoh=flux_incoh,$
  flux_spec=flux_spec,chi2_spec=chi2_spec,$
  flux_corrections=flux_corrections

;if /spec, then calculate the the fluxes for EACH channel and 
;report the median/resistant mean along with the distpersion in the
;sigma = optional output keyword.... 
; full information is outputi n flux_spec and chi2_spec.
ntel=4
dims=size(profiles,/dim)
ndim=n_elements(dims)
if (ndim ne 3) then begin
  print,'must be ndim 3 or wont work in current version'
  return
endif

dimx=dims(0)
dimy=dims(1)
dimz=dims(2)
flux_incoh = fltarr(dimx,dimy,dimz)



if keyword_set(wt_function) eq 0   then wt_function=0

if keyword_set(spec) eq 0 then begin

temp=profiles
n=dimz
temp2 =fltarr(ntel,n)
temp3 = fltarr(n)


for i=0,n-1 do begin
  tp=temp(*,*,i)
  coef=solve4(profile_b1,profile_b2,profile_b3,profile_b4, tp,chi2=chi2,weights=wt_function,result=result)
  temp2(*,i)=coef
  temp3(i)=chi2
  flux_incoh(*,*,i)=result
endfor
flux_all =temp2
chi2_all = temp3

endif else begin ; /spec
 ; do each channel

 flux_spec=fltarr(ntel,dimy,dimz)
 chi2_spec=fltarr(ntel,dimy,dimz)
 flux_sigma=fltarr(ntel,dimz)
for y=0,dimy-1 do begin
  pb1=reform(profile_b1(*,y))
  pb2=reform(profile_b2(*,y))
  pb3=reform(profile_b3(*,y))
  pb4=reform(profile_b4(*,y))
  if wt_function ne 0 then wf=reform(wt_function(*,y)) else wf=0

 for z=0,dimz-1 do begin
  tp = reform(profiles(*,y,z))
  
  coef=solve4(pb1,pb2,pb3,pb4, tp,chi2=chi2,weights=wf,result=result)
  flux_incoh(*,y,z)=result
  flux_spec(*,y,z)=coef
  chi2_spec(*,y,z)=chi2
endfor
endfor

for z=0,dimz-1 do begin
for t=0,ntel-1 do begin
  flux_sigma(t,z) = robust_sigma(flux_spec(t,*,z))
endfor
endfor

  flux_all = median(flux_spec,dim=2)
  chi2_all = median(chi2_spec,dim=2)
  
  
  flux_corrections = flux_spec / (rebin(   reform(flux_all,ntel,1,dimz),ntel,dimy,dimz))


  

endelse


end

