; JDM 2006Sep11 (ah!)
; JDM 2006Dec14 4->4a.  Spped up!
;worker routine for mirc_process4
; JDM 2006Dec18 mirc_engine4a-> mirc_deltaps. Used with mirc_setupcombiner.
;	Stripped down version for calculating the deltaps w/ no exra crap.

pro mirc_roughps,$
    $ ;INPUTS
    num_data, dir, delta,$
    $ ;OUTPUTS
    mircx_data,mircx_2d,$
    $ ; OPTIONAL KEYWORD
    sigmaon=sigmaon,oversample=os

if n_elements(sigmaon) eq 0 then sigmaon=1

if keyword_set(os) eq 0 then os=1

; SETUP
  file0=string( dir+'m',num_data(0),'.fits',format='(a,I4.4,a)')
  td0=float(readfits(file0,head,/silent))
z0=50
dims=size(td0,/dim)
dimx=dims(0)
dimy=dims(1)
dimz=dims(2)

han=hanning(dimx)#replicate(1.d0,dimy)
han3d=rebin(han,dimx,dimy,dimz)
profile_fg = han
profile_fg_spec=profile_fg

for j=0,dimy-1 do begin
  profile_fg_spec(*,j) = profile_fg_spec(*,j)/total(profile_fg_spec(*,j)) 
 ;each spec channel is normed here.
endfor

mircx_data=fltarr(dimx*os,dimy,n_elements(num_data));
mircx_2d  = fltarr(dimx*os,dimy,n_elements(num_data))
tempfft= fltarr(dimx*os,dimy,dimz)

for i=0,n_elements(num_data)-1 do begin
  file0=string( dir+'m',num_data(i),'.fits',format='(a,I4.4,a)')
print,' Processing File: ',file0
badcount=0
tryreadagain:
  td0=float(readfits(file0,head,/silent))
if n_elements(td0) eq 1 then begin
 badcount =badcount +1
 print,' BADCOUNT: ',badcount
 wait,5
 if badcount gt 100 then stop
 goto,tryreadagain
endif
  satframe=sxpar(head,'SATFRAME')-10 ; remove 10 more for safe keeping...
  if satframe le (z0+3) then satframe = dimz-1 ; incase satframe is no good.
  z1 = satframe < (dimz-10-delta) ; ignore last 10 frames. [for deltaps reasons mainly..]

z0a=z0
z1a=z1 
numza=z1a-z0a+1




  td0=td0
  td1=diffdata(td0,sigma=sigmaon)
  temp=fltarr(dimx,dimy)

  profile_incoh = profile_fg
  profile_incoh3d=rebin(profile_incoh,dimx,dimy,dimz)
  profile_incoh3d_spec=rebin(profile_fg_spec,dimx,dimy,dimz)


; Now do some for mirxdata/ps
  
  diffs0=(shift(td0,0,0,-delta)-td0)/delta

; Each SPECTRAL CHANNEL should be subtracted differently...
; since spectrum of input coupled light can shift around.
  sums2d=total(diffs0,1)
  sums2d=reform(sums2d,1,dimy,dimz)
  sums3d_new=rebin(sums2d,dimx,dimy,dimz)
  incoh3d_new = sums3d_new*profile_incoh3d_spec 

  sums=total(total(diffs0,1),1)
  sums3d=rebin(reform(sums,1,1,dimz),dimx,dimy,dimz)
  incoh3d=sums3d*profile_incoh3d

;stop
  diffs0=(diffs0-incoh3d_new)*han3d
  tempfft(0:(dimx-1),*,*)=diffs0

;  bigfft1dx =fft(diffs0,dim=1)
  bigfft1dx=fft(tempfft,dim=1) ; with zeropadding oversampling
  bigfft2dx=fft(fft(tempfft,dim=1),dim=2)
  bigps1dx = float(  bigfft1dx*conj(shift(bigfft1dx,0,0,-1)))
  bigps2dx = float(  bigfft2dx*conj(shift(bigfft2dx,0,0,-1)))

  mircx_data(*,*,i)=total(bigps1dx(*,*,z0a:z1a),3)/numza
  mircx_2d(*,*,i) = total(bigps2dx(*,*,z0a:z1a),3)/numza



endfor


end
