
function mpfunc_vismod4, params,$
    totflux = totflux, err_totflux=totflux_err,$
    rawvis2=rawvis2, err_rawvis2 = rawvis2_err,$ INPUT
    fluxes=fluxes,modelvis2=modelvis2,modtotflux=modtotflux ; OUTPUT

rawvis2=reform(rawvis2)
rawvis2_err=reform(rawvis2_err)
totflux=reform(totflux)


;params = VIS2 for each 6 baselines.
ntel=4

; two step process. 
;first assume params. then calculate the best fits fluxes that go with that
;set of params.
;then calculate resids.

info=size(rawvis2,/dim)
dimb=info(0) ; better be 6
dimz=info(1) ; number of blocks

modelvis2 = fltarr(dimb,dimz)
modtotflux =fltarr(dimz)
fluxes=fltarr(4,dimz)
for i=0,dimz-1 do begin
 vals = rawvis2(*,i)/params
 vals_err=rawvis2_err(*,i)/params
 sum=totflux(i)
 sum_err = totflux_err(i)
 starts = [sum/4.,sum/4.,sum/4.,sum/4.]
 paramsf=mpfit('mpfunc_vismod4_helper',starts,$
         functargs={vals:vals,err_vals : vals_err,$
         sum:sum,err_sum:sum_err},/quiet )
 resids = mpfunc_vismod4_helper(paramsf, vals=vals,err_vals = vals_err,$
         sum=sum, err_sum=sum_err,modvals=modvals,modsum=modsum)
 fluxes(*,i)=paramsf

 modelvis2(*,i) = modvals*params
 modtotflux(i) = modsum
endfor

resid0 = (rawvis2 - modelvis2)/rawvis2_err
resid1 = (totflux - modtotflux)/totflux_err
resids = [ resid0(*),resid1(*)]
return,resids
end



