


pro read_mircarray,file,mircarray

  ; simple format
n=nlines(file)
if n eq 0 then begin
  print,'NO FILE EXIST.'
  mircarray=-1 ; hopefully this will crash the calling program to alert user
  return
endif

mircarray={ b1: ' ',b2: ' ',b3: ' ',b4: ' ',b5: ' ', b6: ' ',$
 mirc:' ',file: ' ',ntel: 0, nbaselines: 0, ntriangles:0 ,$
 ihelp:ptr_new(fltarr(6)), jhelp:ptr_new(fltarr(6)), $
 itrihelp: ptr_new(fltarr(6)),jtrihelp: ptr_new(fltarr(6)), $
 ktrihelp: ptr_new(fltarr(6)),itribase: ptr_new(fltarr(6)), $
 jtribase: ptr_new(fltarr(6)),ktribase:  ptr_new(fltarr(6)) }
mircarray.file=file
a=strarr(n)
temp=' '
openr,unit,file,/get
for i=0,n-1 do begin
 readf,unit,temp
 a(i)=temp
endfor

for i=0,n-1 do begin
  av=string_vector(a(i))
  if av(0) eq 'B1' then mircarray.b1 = av(1)
  if av(0) eq 'B2' then mircarray.b2 = av(1)
  if av(0) eq 'B3' then mircarray.b3 = av(1)
  if av(0) eq 'B4' then mircarray.b4 = av(1)
  if av(0) eq 'B5' then mircarray.b5 = av(1)
  if av(0) eq 'B6' then mircarray.b6 = av(1)

  if av(0) eq 'MIRC' then mircarray.mirc = av(1) ; style of array [someday 6]
endfor


close,unit
free_lun,unit

if mircarray.mirc eq 4 then begin
  mircarray.ntel=4
  mircarray.nbaselines=6
  mircarray.ntriangles=4
  mircarray.ihelp=ptr_new([0,0,0,1,1,2]) ; map (tel i, tel j) -> baseline #
  mircarray.jhelp=ptr_new([1,2,3,2,3,3])
  mircarray.itrihelp=ptr_new([0,0,0,1]) ; tel-> tri
  mircarray.jtrihelp=ptr_new([1,1,2,2])
  mircarray.ktrihelp=ptr_new([2,3,3,3])
  mircarray.itribase=ptr_new([0,0,1,3])        ; base-> tri
  mircarray.jtribase=ptr_new([3,4,5,5])
  mircarray.ktribase=ptr_new([1,2,2,4])
endif


end

