;JDM 2002Mar27
;JDM 2003Feb18
;JDM 2004Feb16 Modified to read lambda!
;JDM 2006Sep09 Modified from IONIC3 to MIRC
;
; Reads config file for analyzing data
;
; returns instructure: structure containing all
; information about the masterlogfile
pro read_mirclog,file,instructure,num_data=num_data

temp={star:' ',dir:' ',mode:' ', block: 0, type:' ',firstfile: 1, lastfile: 2, shutblock:[-1,-1,-1,-1,-1],daqdir:' '}
daqdir=''
nl=nlines(file)
if (nl eq 0) then begin
 print,'USAGE: read_mirclog,file,instructure,num_data=num_data
 num_data=-1
 instructure=-1
 return
endif

instructure=replicate(temp,nl)
good=intarr(nl)
num_data=0
a=' '
lastgood=-1
openr,unit,file,/get
for i=0,nl-1 do begin
readf,unit,a 
 fc=strmid(a,0,1)
 if (fc ne '#'and strlen(a) gt 0) then begin
   av=string_vector(a)
   if (av(0) eq 'DIR') then begin
      dir=av(1)
   endif
   if (av(0) eq 'DAQDIR') then begin
      daqdir=av(1)
   endif
   if (av(0) ne 'DIR' and av(0) ne 'DAQDIR') then begin

      good(i) =1
      instructure(i).star=av(0)
      instructure(i).mode=av(1)
      instructure(i).block=fix(av(2))
      instructure(i).type=av(3)
      instructure(i).firstfile = fix(av(4))
      instructure(i).lastfile = fix(av(5))
      if av(3) eq 'DATA' then begin
        num_data=num_data+1
        nshut=n_elements(av)-6
        for j=0,nshut-1 do begin
          instructure(i).shutblock(j)=fix(av(6+j))
        endfor
 
     endif

  endif

  endif
endfor
close,unit & free_lun,unit

in=where(good eq 1,ct)
if (ct eq 0) then begin
 print,'No config information -- all comments!'
 return
endif
instructure=instructure(in)
instructure(*).dir = dir
instructure(*).daqdir=daqdir

end






	
