;
function solve4, profile_b1, profile_b2,profile_b3,profile_b4,profile_data,$
  result=result,chi2=chi2, weights=wts
; returns a vector of 4 coefficients
; wt: option weights .. .same size as inputs.



; Will find decomposition of profiles that best fits the data
; profiles can be any dimension (linear or 2-D)

if keyword_set(wts) eq 0 then begin ; noweights

aa=total(profile_b1*profile_b1)
ab=total(profile_b1*profile_b2)
ac=total(profile_b1*profile_b3)
ad=total(profile_b1*profile_b4)
af=total(profile_b1*profile_data)

bb=total(profile_b2*profile_b2)
bc=total(profile_b2*profile_b3)
bd=total(profile_b2*profile_b4)
bf=total(profile_b2*profile_data)

cc=total(profile_b3*profile_b3)
cd=total(profile_b3*profile_b4)
cf=total(profile_b3*profile_data)

dd=total(profile_b4*profile_b4)
df=total(profile_b4*profile_data)

matrix=[  [aa,ab,ac,ad], $
          [ab,bb,bc,bd], $
          [ac,bc,cc,cd], $
          [ad,bd,cd,dd] ]
y = [ af, bf, cf, df ]

endif else begin ; do weights!
aa=total(profile_b1*profile_b1*wts*wts)
ab=total(profile_b1*profile_b2*wts*wts)
ac=total(profile_b1*profile_b3*wts*wts)
ad=total(profile_b1*profile_b4*wts*wts)
af=total(profile_b1*profile_data*wts*wts)

bb=total(profile_b2*profile_b2*wts*wts)
bc=total(profile_b2*profile_b3*wts*wts)
bd=total(profile_b2*profile_b4*wts*wts)
bf=total(profile_b2*profile_data*wts*wts)

cc=total(profile_b3*profile_b3*wts*wts)
cd=total(profile_b3*profile_b4*wts*wts)
cf=total(profile_b3*profile_data*wts*wts)

dd=total(profile_b4*profile_b4*wts*wts)
df=total(profile_b4*profile_data*wts*wts)


matrix=[  [aa,ab,ac,ad], $
          [ab,bb,bc,bd], $
          [ac,bc,cc,cd], $
          [ad,bd,cd,dd] ]
y = [ af, bf, cf, df ]
endelse


matrix_invert=invert(matrix)
x= matrix_invert#y
result=x(0)*profile_b1 + x(1)*profile_b2 + x(2)*profile_b3+x(3)*profile_b4
chi2=total((result-profile_data))^2/n_elements(profile_data)


return,x

end
