; JDM 2006Aug11
; adopted from RT code on mirkwood
; order must be 12 13 14 23 24 34

function  bootstrap_opd4,  opds0,wts, newopds=newopds
  wmeanopd=fltarr(3)
  newopds=fltarr(6)

  w=wts
  opd=opds0
  in =where(w lt 1,ct)
  if ct gt 0 then opd(in)=0.0

  opd12=OPD[0];
  opd13=OPD[1];
  opd14=OPD[2];
  opd23=OPD[3];
  opd24=OPD[4];
  opd34=OPD[5];

  w12=w[0]>.01
  w13=w[1]>.01
  w14=w[2]>.01
  w23=w[3]>.01
  w24=w[4]>.01
  w34=w[5]>.01
 b1=opd12*w12-opd23*w23-opd24*w24;
  b2=opd13*w13+opd23*w23-opd34*w34;
  b3=opd14*w14+opd24*w24+opd34*w34;

  a11=w12+w23+w24;
  a12=-w23;
  a13=-w24;
  a21=a12;
  a22=w13+w23+w34;
  a23=-w34;
  a31=a13;
  a32=a23;
  a33=w14+w24+w34;

  i11=a33*a22-a32*a23;
  i12=-1*(a33*a12-a32*a13);
  i13=a23*a12-a22*a13;
  i21=-1*(a33*a21-a31*a23);
  i22=a33*a11-a31*a13;
  i23=-1*(a23*a11-a21*a13);
  i31=a32*a21-a31*a22;
  i32=-1*(a32*a11-a31*a12);
  i33=a22*a11-a21*a12;

  deta=a11*(a33*a22-a32*a23)-a21*(a33*a12-a32*a13)+a31*(a23*a12-a22*a13);

  wMeanOPD[0]=(i11*b1 +i12*b2 + i13*b3)/deta;
  wMeanOPD[1]=(i21*b1 +i22*b2 + i23*b3)/deta;
  wMeanOPD[2]=(i31*b1 +i32*b2 + i33*b3)/deta;

newopds(0)=wmeanopd(0)
newopds(1)=wmeanopd(1)
newopds(2)=wmeanopd(2)
newopds(3)=wmeanopd(1)-wmeanopd(0)
newopds(4)=wmeanopd(2)-wmeanopd(0)
newopds(5)=wmeanopd(2)-wmeanopd(1)



 return,wmeanopd ; return minimal set 12,13,14


end
