;
function solve6, profile_b1, profile_b2,profile_b3,profile_b4,profile_b5,profile_b6,profile_data,$
  result=result,chi2=chi2
; returns a vector of 6 coefficients
  

; Will find decomposition of profiles that best fits the data
; profiles can be any dimension (linear or 2-D)

aa=total(profile_b1*profile_b1)
ab=total(profile_b1*profile_b2)
ac=total(profile_b1*profile_b3)
ad=total(profile_b1*profile_b4)
ae=total(profile_b1*profile_b5)
af=total(profile_b1*profile_b6)
ay=total(profile_b1*profile_data)

bb=total(profile_b2*profile_b2)
bc=total(profile_b2*profile_b3)
bd=total(profile_b2*profile_b4)
be=total(profile_b2*profile_b5)
bf=total(profile_b2*profile_b6)
by=total(profile_b2*profile_data)

cc=total(profile_b3*profile_b3)
cd=total(profile_b3*profile_b4)
ce=total(profile_b3*profile_b5)
cf=total(profile_b3*profile_b6)
cy=total(profile_b3*profile_data)

dd=total(profile_b4*profile_b4)
de=total(profile_b4*profile_b5)
df=total(profile_b4*profile_b6)
dy=total(profile_b4*profile_data)

ee=total(profile_b5*profile_b5)
ef=total(profile_b5*profile_b6)
ey=total(profile_b5*profile_data)

ff=total(profile_b6*profile_b6)
fy=total(profile_b6*profile_data)



matrix=[  [aa,ab,ac,ad,ae,af], $
          [ab,bb,bc,bd,be,bf], $
          [ac,bc,cc,cd,ce,cf], $
          [ad,bd,cd,dd,de,df], $
          [ae,be,ce,de,ee,ef], $
          [af,bf,cf,df,ef,ff] ]
y = [ ay, by, cy, dy ,ey, fy]

matrix_invert=invert(matrix)
x= matrix_invert#y
result=x(0)*profile_b1 + x(1)*profile_b2 + x(2)*profile_b3+x(3)*profile_b4+$
       x(4)*profile_b5 + x(5)*profile_b6
chi2=total((result-profile_data))^2/n_elements(profile_data)
return,x

end
