; 2006Dec20. JDM. Added SATFRAME keyword to directory of coadded data.

pro add_satframe,plotit=plotit

  result=dialog_pickfile(/dir,path=dir0,tit="Choose COADD Directory to Process:",get_path=get_path)


pre='m'
suf='.fits'

; First confirm there are fits files in this directory with correct name.
find_files,files,filnams,dir=result,filext=suf
; Check prefix too
n=n_elements(files)
if n eq 0 then begin
  print,' No appropriate data files in: ',result
  stop
endif
good=intarr(n) 
for i=0,n-1 do begin
  a=strpos(filnams(i),pre)
  if a eq 0 then good(i)=1
endfor
goodin=where(good eq 1,n)
if n eq 0 then begin
  print,' No appropriate data files in: ',result
  stop
endif
files=files(goodin)
filnams=filnams(goodin)

for i=0,n-1 do begin
;print,'Working on File: ',files(i)

satframe0 = mirc_saturation_file(files(i),/add,satframe=satframe)

if keyword_set(plotit) then begin
 if (max(satframe)-min(satframe) ne 0) then begin
    image_cont,-satframe,/noc,tit=string(i)
    print,min(satframe0),files(i)
  endif
endif


endfor




end
