; 2006Dec14 JDM

PRO BOOT_MEAN_dim, array, means, sigmas, dim=dim,num=num

; dim= what dimension to do bootstrap.  should be fast for multi-dim data.
 ;     1,2,3,4,... (does not start at 0)
; MAX 8

; default is to bootstrap along the last dimension

if keyword_set(num) eq 0 then num=50

info=size(array,/dim)
ndim=n_elements(info)
if keyword_set(dim) eq 0 then dim=ndim
n=info(dim-1)

; shuffle the bootable dimension to front
tvector=indgen(ndim)
tvector(0)=dim-1
tvector(dim-1)=0

newarray=array
if dim ne 1 then begin ; don't reorder if first.
 newarray=transpose(array,tvector)
endif
newinfo=size(newarray,/dim)
temp=newarray(0,*,*,*,*,*,*,*)  
newinfo(0)=num
newinfo0=newinfo
newinfo0(0)=1
meansb=rebin(temp,newinfo)




FOR L=0,Num-1 DO BEGIN
; Uniform random numbers between 0 and N-1:
  PICK=RANDOMU(seed,N)
  R=FIX(PICK*N)
  meansb(l,*,*,*,*,*,*,*) = total(  newarray(r,*,*,*,*,*,*,*) ,1)/n
endfor

;realmeans = total(
means = total(meansb,1)/num

; now do sigma in parallel form.
means_plus = rebin(reform(means,newinfo0),newinfo)
diff_plus=(meansb-means_plus)^2
sigmas= sqrt(total(diff_plus,1)/num)

if dim ne 1 then begin
 means=reform(    transpose(  reform(means,newinfo0),tvector))
 sigmas=reform(   transpose(  reform(sigmas,newinfo0),tvector))
endif 


RETURN
END
